/*
   DoUntilTable.prg
   A sample dBL program from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2012. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 21
   Program to show looping through a table.
*/

dSample = new database()
dSample.databaseName := "DBASESAMPLES"
dSample.active       := true

qFish = new query()
qFish.database := dSample
qFish.sql      := "select * from fish"
qFish.active   := true
// set the index:
qFish.rowset.indexName := "name"
// go to the first row:
qFish.rowset.first()

// loop until we reach the end of the rowset:
do 

   ? qFish.rowset.fields["Name"].value
 
   // very important: without this, we will
   // create an infinite loop, and only ever
   // display the value of the data from the
   // first row!
   qFish.rowset.next()
until qFish.rowset.endOfSet

// some cleanup:
qFish.active := false
release object qFish
dSample.active := false
release object dSample
