/*
   NavigateMasterEx.prg
   A sample dBL program from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2012. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 8
   Example of the sort sequence on the rowsets when using the
   navigateMaster property of the child rowset.
*/

// If table does not exist, run routine
// for this chapter that creates the tables ...
if not file("ParentTest.dbf")
   do MakeChapter8Tables
endif

// navigateMaster example:
clear
// Parent table:
qParent = new query()
qParent.sql := "select * from ParentTest"
qParent.active := true
// short references:
rParent = qParent.rowset
fParent = rParent.fields

// Child table:
qChild = new query()
qChild.sql := "select * from ChildTest"
qChild.active := true
// short references:
rChild = qChild.rowset
fChild = rChild.fields
// set the index:
rChild.indexName := "LinkField"
// set the masterRowset/masterFields:
rChild.masterRowset := rParent
rChild.masterFields := "LINKFIELD"
// the navigateMaster property is not set, 
// and is the default: false
? "navigateMaster = false"

// navigate through the master table, and show the linked data:
rChild.first()
do while not rChild.endOfSet
   ? fParent["ParentData"].value+" "+;
     fChild["ChildData"].value
rChild.lockRow()
? rParent.isRowLocked()
   rChild.next()
enddo

// now set the navigateMaster to true:
rChild.navigateMaster := true
?
? "navigateMaster = true"
// navigate through the master table, and show the linked data:
rChild.first()
do while not rChild.endOfSet
   ? fParent["ParentData"].value+" "+;
     fChild["ChildData"].value
   rChild.next()
enddo



